#!/usr/bin/perl -i
#
#             2- ,        ,        
#      
#   1  G-  ,  2  G-     1.gcode  2.gcode ,    ,    ,      .


#      
# perl -d d:\UP_to_num_layers.pl d:\Etalon.gcode

#       Notepad++,    
# ->_,      :
# C:\Strawberry\perl\bin\perl.exe -d "$(FULL_CURRENT_PATH)" D:\Etalon.gcode
#            
#  ,      Perl  

#       
# DB<1>b num   num  ,     		152
# DB<2>c             
# DB<3>s	       

use strict;
use warnings;
use File::Basename;
use File::Copy;

my $dirname = dirname(__FILE__);	    #      
my $RESULTHANDLE ="$dirname/Threated_1_2.gcode"; 	#     
my $HANDLE1 ="$dirname/1.gcode";		#    1.gcode       
my $HANDLE2 ="$dirname/2.gcode";     	#    2.gcode       
										#            Perl

my $String='';							#  
my $PrevXY='';							#         X, Y          
my $CurrentZ='';						#         Z               
										# ..        G_ ,         ,    
my $Extruder=""; 						#            
my $Plasma=""; 							#             
my $Retract="G1 E-15 F2800.00  ; Retract to 15mm";			#      
my $UnRetract="G1 E15.3 F2800.00  ; Unretract to 15,3mm";	#       
my $PlasmaON="M106 P1 S255 ; Turn ON Cold Plasma Torch";	#    
my $PlasmaOFF="M106 P1 S0 ; Turn OFF Cold Plasma Torch";	#    
my $CharPos=0;							#     
my $tmp;

my @Strings1=();					    #  ,    1 
my @Strings2=();					    #  ,    2 
my $Array1Size= 0;						#     @Strings1
my $Array2Size= 0;						#     @Strings2

my $Flag=0;
my $FlagZ=0;
my $EndFlag=0;


if (-e $RESULTHANDLE)
{
unlink($RESULTHANDLE);					#          ,   ,     - 
} 
system("echo>$RESULTHANDLE");			#         DOS
open (RESULTFILE, ">$RESULTHANDLE");	#   
seek(RESULTFILE,0,0);					#     
truncate(RESULTFILE, 0);				#    
close(RESULTFILE);						#  

open (FILE1, "< $HANDLE1") || die "\n FILE NOT EXIST \n \n";		#   1     
open (FILE2, "< $HANDLE2") || die "\n FILE NOT EXIST \n \n";		#   2     
print("Files opened \n");
print("1_2_Combine.pl \n");

while (<FILE1>) 
{ #       
	if(/G1 X/)
		{
		$PrevXY=$_ . " " ;
		$CharPos=index($PrevXY, 'E');
		$PrevXY=substr($PrevXY,0,$CharPos-1);	#    E
		}
		
	if(/G1 Z/)
		{
		$CurrentZ=$_;
		$CurrentZ=substr($CurrentZ,0,length($CurrentZ)-1);
		}
		
	if(/M77/)	#       1   
		{
		if($EndFlag==0)
			{
			$String=";###\n"; # nil
			push(@Strings1, $String);
			$Array1Size++;
			$EndFlag++;
			}
		}
		
	if(/;LAYER_CHANGE/)
		{
		if($Flag<2)			#        .           
			{
			$String=$_;
			push(@Strings1, $String);
			$Array1Size++;
			$Flag++;
			}
		else
			{
			$String=";###\n"; # nil
			push(@Strings1, $String);
			
			$Extruder=";Extruder \n$PlasmaOFF \n$CurrentZ \n$PrevXY \nG92 E0 \n$UnRetract \n"; 
			push(@Strings1, $Extruder);
			$String=$_;
			push(@Strings1, $String);
			$Array1Size=$Array1Size+3;
			}
		}
	else
		{
		if($EndFlag==0)
			{
			$String=$_;
			push(@Strings1, $String);
			$Array1Size++;
			}
		}
	
	if($EndFlag==1)	#           1 
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp eq ";")			#     ,      2
			{
			$EndFlag=2;	 		#      
			}
		else
			{
			$String=$_;
			push(@Strings1, $String);
			$Array1Size++;
			}
		}
}
close(FILE1);		#  


$Flag=0;
$EndFlag=0;
while (<FILE2>) 
{ #       
	if(/G1 Z/)
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp ne ";")
			{
			$FlagZ=1;
			}
		}

	if(/;LAYER_CHANGE/)
		{
		$Flag=1;						#       
		$String=";###\n"; # nil
		push(@Strings2, $String);		#        
		$Plasma=";Plasma \nG92 E0 \n$Retract \n";
		push(@Strings2, $Plasma);		#         
		$Array2Size=$Array2Size+2;
		}
	else
		{
		if(($Flag==1) && ($EndFlag==0) && ($FlagZ==0))
			{
			$String=$_;
			push(@Strings2, $String);
			$Array2Size++;
			}
			
		if(($Flag==1) && ($EndFlag==0) && ($FlagZ==1))
			{
			$Plasma=$_;
			$Plasma=substr($Plasma,0,length($Plasma)-1);
			$Plasma="$Plasma \n$PlasmaON \nG4 S2 ; Wait 2 seconds to guarantee ignite torch\n";
			#       ,    ,   
			#  2            
			push(@Strings2, $Plasma);
			$Array2Size++;
			$FlagZ=0;
			}
		}
	
	if($EndFlag==1)	#            2 
		{
		$tmp=$_;
		$tmp=substr($tmp,0,1);
		if($tmp eq ";")			#     ,      2
			{
			$EndFlag=2;	#      
			}
		else
			{
			$String=$_;
			push(@Strings2, $String);
			$Array2Size++;
			}
		}
		
	if(/;END gcode/)	#    G-,         .
		{
		$EndFlag=1;
		}	
}
$String=";###\n"; # nil
push(@Strings2, $String);		#        ,      
								#         while
$Array2Size++;
close(FILE2);					#  



$String = shift(@Strings2);		#       @Strings2,  , ..    
$Array2Size--;

$Flag=0;
open (RESULTFILE, ">$RESULTHANDLE") || die "\n FILE NOT EXIST \n \n";	#   ,    
#      2-    
while(($Array1Size>0) || ($Array2Size>0))
	{
	$String = @Strings1[0];
	$tmp = shift(@Strings1);			#       @Strings1,  
	$Array1Size--;

	if($String ne ";###\n")#nil	#   @Strings1   
		{
		syswrite(RESULTFILE, $String, length($String));		#       
		}
	else				#    ,        
		{
		$String="#";
		while($String ne ";###\n")#nil	#             
			{
			$String = @Strings2[0];
			$tmp = shift(@Strings2);			#       @Strings2,  
			$Array2Size--;
				
			if($String ne ";###\n")#nil				#   @Strings2   
				{
				syswrite(RESULTFILE, $String, length($String));		#       
				}
			}
			
		}
	}

close(RESULTFILE);